package mactrans.system2;

/**
 * This is the abstract class which must be implemented by all
 * classes producing MacTrans-results
 *  
 * @author Jan Kienecker (3kieneck@informatik.uni-hamburg.de)
 * @version $Revision: 1.1 $
 * 
 * <pre>
 * $Log: MachineTranslationProcessor.java,v $
 * Revision 1.1  2005/05/25 12:54:41  jkieneck
 * + added to repository
 *
 * </pre>
 */
public abstract class MachineTranslationProcessor extends MachineTranslationClass {
	/**
	 * Implement this method to reset your local data
	 *
	 */
	public abstract void initialize();
	
	/**
	 * Use this method to invoke your algorithm. 
	 * 
	 * @return the result of your operation, any Object as a result is okay.
	 */
	public abstract Object proceed();
}
