
use lib "/home/veronika/ebmt";
use memory;

sub find_coverage
# input is 
#  - the input sentence structure enhanced with matching and shared chunks
#  - translation memory
#  - debug
{
  my %coverage;
  $sorted_chunks = sort_matching_chunks_by_length($_[0]->{chunks}, $_[1], $_[2]);
  foreach my $occurance (@$sorted_chunks)
  {
    print "trying to cover by CHUNK $occurance->{sentence_id} $occurance->{chunk_number}\n";
    foreach my $mat_pos (keys %{ $_[0]->{chunks}{$occurance} })
    {
      @matching_positions = split(/,/, $mat_pos);
      print "  trying to cover: ";
      foreach my $position (@matching_positions) {print $position}; print "\n";
      if(can_be_added_to_coverage(\@matching_positions, \%coverage))
      {
        add_chunk_to_coverage($occurance, \@matching_positions, \%coverage)
      }
    }
  }
  \%coverage
#  @{$_[0]->{chunks}} = sort {$b -> {cislo} <=> $a -> {cislo}} @pole;
}


sub sort_matching_chunks_by_length()
# input is 
#  - the sentence->{chunks} structure
#  - translation memory
#  - debug
{
  my ($chunks, $memory, $debug) = @_;
  my @sorted_chunks = sort { memory_get_chunk_elements($memory, $b, $debug) <=> memory_get_chunk_elements($memory, $a, $debug) } keys %$chunks;
  \@sorted_chunks
}

sub can_be_added_to_coverage
{
  my ($matching_positions, $coverage) = @_;
  foreach $mp (@$matching_positions)
  {
    if ( defined $coverage->{sequence}[$mp]) {
     print "word number $mp already covered\n";
     return 0 
    }
  }
  1
}


sub add_chunk_to_coverage
{
  my($occurance, $matching_positions, $coverage) = @_;
  $mp = join(",", @$matching_positions);
  $coverage->{chunks}{$mp} = $occurance;
  foreach $word_index (@$matching_positions)
  {
    print "covering position ",$word_index," - part of $mp \n";	
    $coverage->{sequence}[$word_index] = 1;
  }
}


sub print_coverage
{
  my($coverage, $target_lang_mem) = @_;
  print "COVERAGE: \n";
  my @tsentence;

  while(my ($key, $val) = each %{ $coverage->{chunks} })
  {
  my $twords = transfer($target_lang_mem, $val); my  $i = 0;
#  foreach my $word ( split(/,/, $key) ) { push @tsentence, @$twords}
    my $tr=join(' ', @{ $twords });
    print "\t input words", $key," \t chunk: tm sentence", $val->{sentence_id}, " ,chunk ", $val->{chunk_number}, , "\n";
    push @tsentence, $key.'-'.$tr;
  }
  @tsentence = sort {$a cmp $b} @tsentence;
  foreach my $word(@tsentence) {print "$word "}; print "\n";
  print "END OF COVERAGE \n";
  print join(" ",@tsentence), "\n";
}

1
